Index: src/rtgplot.h
===========================================================================
--- src/rtgplot.h	2004/11/03 14:26:17	#5
+++ src/rtgplot.h	2004/11/03 14:26:17
@@ -47,7 +47,11 @@
 
 /* Populate a data_t per item to plot */
 typedef struct data_struct {
-    long long counter;		// interval sample value
+#ifdef HAVE_UNSIGNED_LONG_LONG
+    unsigned long long counter;	// interval sample value
+#else
+    unsigned long counter;
+#endif
     unsigned long timestamp;	// UNIX timestamp
     float rate;			// floating point rate
     int x;			// X plot coordinate
@@ -57,7 +61,11 @@
 
 /* If calculating rate, a rate_t stores total, max, avg, cur rates */
 typedef struct rate_struct {
+#ifdef HAVE_UNSIGNED_LONG_LONG
     unsigned long long total;
+#else
+    unsigned long total;
+#endif
     float max;
     float avg;
     float cur;
@@ -184,7 +192,7 @@
 void init_colors(gdImagePtr *, color_t **);
 void calculate_rate(data_t **, rate_t *, int);
 void calculate_total(data_t **, rate_t *, int);
-#ifdef HAVE_STRTOLL
+#ifdef HAVE_LONG_LONG
 long long intSpeed(void *, int);
 #else
 long intSpeed(void *, int);
Index: src/rtgpoll.c
===========================================================================
--- src/rtgpoll.c	2004/11/03 14:26:17	#5
+++ src/rtgpoll.c	2004/11/03 14:26:17
@@ -3,35 +3,41 @@
    Author:      $Author: cbrotsos $
    Date:        $Date: 2004/08/25 19:22:33 $
    Description: RTG SNMP get dumps to MySQL database
+   Do You:      $Yahoo$
 ****************************************************************************/
 
 #define _REENTRANT
 #include "common.h"
 #include "rtg.h"
+#include "rtghash.h"
+#include "rtgsqlbuf.h"
+#include "rtgsnmp.h"
 
 /* Yes.  Globals. */
 stats_t stats =
-{PTHREAD_MUTEX_INITIALIZER, 0, 0, 0, 0, 0, 0, 0, 0, 0.0};
-char *target_file = NULL;
-target_t *current = NULL;
-char *pid_file = PIDFILE;
-#ifndef FEATURES
-  #if HAVE_MYSQL
-  MYSQL mysql;
-  #endif
+{ PTHREAD_MUTEX_INITIALIZER, 0, 0, 0, 0, 0, 0, 0, 0,
+#ifdef FEATURES
+	0, 0,
 #endif
-int entries = 0;
+	0.0 };
 
-#if NEW_TARGET_FORMAT
+target_t *current = NULL;
 config_t set;
-int lock;
-int waiting;
 char config_paths[CONFIG_PATHS][BUFSIZE];
-#endif
 
 /* dfp is a debug file pointer.  Points to stderr unless debug=level is set */
 FILE *dfp = NULL;
 
+/* Yes. File-scoped statics. */
+static char *pid_file;
+static char *target_file = NULL;
+static int waiting;
+static int lock;
+static unsigned int hashsize = 10000U;
+static void print_stats(void);
+#if HAVE_MYSQL
+static MYSQL dbh_mysql;
+#endif
 
 /* Main rtgpoll */
 int main(int argc, char *argv[]) {
@@ -41,23 +47,17 @@
     struct timeval now;
     double begin_time, end_time, sleep_time;
     char *conf_file = NULL;
-    char errstr[BUFSIZE];
-    int ch, i;
+    int ch;
+    unsigned int i;
 
-	dfp = stderr;
-
-    /* Check argument count */
-    if (argc < 3)
-	usage(argv[0]);
+    dfp = stderr;
+    pid_file = PIDFILE;
 
 	/* Set default environment */
-    config_defaults(&set);
-#if NEW_TARGET_FORMAT
-    init_hash();
-#endif
+    config_defaults();
 
     /* Parse the command-line. */
-    while ((ch = getopt(argc, argv, "c:dhmDt:vz")) != EOF)
+    while ((ch = getopt(argc, argv, "c:dhmDs:t:vz")) != EOF) {
 	switch ((char) ch) {
 	case 'c':
 	    conf_file = optarg;
@@ -79,6 +79,9 @@
 	case 'p':
 	    pid_file = optarg;
 	    break;
+	case 's':
+	    hashsize = atoi(optarg);
+	    break;
 	case 't':
 	    target_file = optarg;
 	    break;
@@ -88,16 +91,23 @@
 	case 'z':
 	    set.withzeros = TRUE;
 	    break;
+	default:
+	    usage(argv[0]);
+	    break;
 	}
+    }
 
 	debug(LOW, "RTG version %s starting.\n", VERSION);
 
 	if (set.daemon) {
 		if (daemon_init() < 0)
 			fatal("Could not fork daemon!\n");
-		debug(LOW, "Daemon detached\n");
+		debug(HIGH, "Daemon detached\n");
 	}
 
+	thash = malloc(sizeof(struct tgthash));
+	tgthash_init(thash, hashsize);
+	sqlbuf_init();
 
     /* Initialize signal handler */
     sigemptyset(&signal_set);
@@ -110,77 +120,61 @@
 	if (!set.multiple) 
 		checkPID(pid_file);
 
-    if (pthread_sigmask(SIG_BLOCK, &signal_set, NULL) != 0)
-		printf("pthread_sigmask error\n");
+	if (pthread_sigmask(SIG_BLOCK, &signal_set, NULL) != 0)
+		fatalfile(dfp, "pthread_sigmask error\n");
 
     /* Read configuration file to establish local environment */
     if (conf_file) {
-      if ((read_rtg_config(conf_file, &set)) < 0) 
-		fatal("Could not read config file: %s\n", conf_file);
+      if ((read_rtg_config(conf_file)) < 0) 
+		fatalfile(dfp, "Could not read config file: %s\n", conf_file);
     } else {
       conf_file = malloc(BUFSIZE);
       if (!conf_file) 
          fatal("Fatal malloc error!\n");
       for(i=0;i<CONFIG_PATHS;i++) {
         snprintf(conf_file, BUFSIZE, "%s%s", config_paths[i], DEFAULT_CONF_FILE); 
-        if (read_rtg_config(conf_file, &set) >= 0)
+        if (read_rtg_config(conf_file) == 0)
            break;
-        if (i == CONFIG_PATHS-1) {
-			snprintf(conf_file, BUFSIZE, "%s%s", config_paths[0], DEFAULT_CONF_FILE); 
-			if ((write_rtg_config(conf_file, &set)) < 0) 
-				fatal("Couldn't write config file.\n");
-        }
       }
     }
 
+    /* Initialize the SNMP session */
+    debug(HIGH, "Initializing SNMP.\n");
+    rtg_init_snmp();
+
     /* hash list of targets to be polled */
-	entries = hash_target_file(target_file);
-    if (entries <= 0) 
-		fatal("Error updating target list.");
+    if (!hash_target_file(target_file))
+	fatal("Error initializing target list.\n");
 
-	debug(LOW, "Initializing threads (%d).\n", set.threads);
-    pthread_mutex_init(&(crew.mutex), NULL);
-    pthread_cond_init(&(crew.done), NULL);
-    pthread_cond_init(&(crew.go), NULL);
-    crew.work_count = 0;
 
-    /* Initialize the SNMP session */
-#if NEW_TARGET_FORMAT
-	debug(LOW, "Initializing SNMP (port %d).\n", set.snmp_port);
-#else
-	debug(LOW, "Initializing SNMP (v%d, port %d).\n", 
-		set.snmp_ver, set.snmp_port);
-#endif
-    init_snmp("RTG");
-
     /* Attempt to connect to the MySQL Database */
-#ifndef FEATURES
- #if HAVE_MYSQL
-    if (!(set.dboff)) {
-		if (mysql_dbconnect(set.dbdb, &mysql) < 0) 
+#if HAVE_MYSQL
+	if (!(set.dboff)) {
+		if (mysql_dbconnect(set.dbdb, &dbh_mysql) != 0) 
 			fatal("** Database error - check configuration.\n");
-		if (!mysql_ping(&mysql))
+		if (!mysql_ping(&dbh_mysql))
 			debug(LOW, "connected.\n");
 		else
 			fatal("server not responding.\n");
-    }
- #endif
-#else
- #if HAVE_MYSQL
-	my_init();
- #endif
+		sqlbuf_db_mysql(&dbh_mysql);
+		dbtable_sqltune_all();
+	}
 #endif
 
-
-	debug(HIGH, "\nStarting threads.\n");
-    for (i = 0; i < set.threads; i++) {
+	pthread_mutex_init(&(crew.mutex), NULL);
+	pthread_cond_init(&(crew.done), NULL);
+	pthread_cond_init(&(crew.go), NULL);
+	crew.work_count = 0;
+	debug(LOW, "Initializing threads (%hu).\n", set.threads);
+	for (i = 0; i < set.threads; i++) {
 		crew.member[i].index = i;
 		crew.member[i].crew = &crew;
-		if (pthread_create(&(crew.member[i].thread), NULL, poller, (void *) &(crew.member[i])) != 0)
-			printf("pthread_create error\n");
+		if (pthread_create(&(crew.member[i].thread), NULL, poller,
+		    &(crew.member[i])))
+			fatal("pthread_create poller %u error\n", i);
 	}
-    if (pthread_create(&sig_thread, NULL, sig_handler, (void *) &(signal_set)) != 0)
-		printf("pthread_create error\n");
+	if (pthread_create(&sig_thread, NULL, sig_handler, &(signal_set)))
+		fatal("pthread_create sig_handler error\n");
 
     /* give threads time to start up */
     sleep(1);
@@ -192,62 +186,60 @@
 	lock = TRUE;
 	gettimeofday(&now, NULL);
 	begin_time = (double) now.tv_usec / 1000000 + now.tv_sec;
+        stats.round++;
 
 	PT_MUTEX_LOCK(&(crew.mutex));
-	init_hash_walk();
-	current = getNext();
-	crew.work_count = entries;
+	tgthash_init_walk(thash);
+	current = tgthash_next(thash);
+	crew.work_count = thash->entries;
 	PT_MUTEX_UNLOCK(&(crew.mutex));
 	    
-	if (set.verbose >= LOW) {
-		if (set.daemon)
-			sysloginfo("Queue ready, broadcasting thread go condition.");
-		else
-        	timestamp("Queue ready, broadcasting thread go condition.");
-	}
+	SPT("polling %u targets, %u hosts", thash->entries, host_count());
+	debug(LOW, "Queue ready (%u), broadcasting go condition.\n",
+	      crew.work_count);
 	PT_COND_BROAD(&(crew.go));
 	PT_MUTEX_LOCK(&(crew.mutex));
 	    
-	while (crew.work_count > 0) {
+	while (crew.work_count) {
 		PT_COND_WAIT(&(crew.done), &(crew.mutex));
 	}
 	PT_MUTEX_UNLOCK(&(crew.mutex));
+	if (stats.round) {
+		SPT("flushing result into database");
+		sqlbuf_flush();
+	}
 
+	lock = FALSE;
+	if (waiting) {
+		SPT("reloading %s", target_file);
+		debug(HIGH, "Processing pending SIGHUP.\n");
+		hash_target_file(target_file);
+		dbtable_sqltune_all();
+		waiting = FALSE;
+	} else if (delete_targets(thash, ERR))
+		dbtable_sqltune_all();
+
 	gettimeofday(&now, NULL);
-	lock = FALSE;
 	end_time = (double) now.tv_usec / 1000000 + now.tv_sec;
 	stats.poll_time = end_time - begin_time;
-        stats.round++;
 	sleep_time = set.interval - stats.poll_time;
 
-	if (waiting) {
-		debug(HIGH, "Processing pending SIGHUP.\n");
-	    entries = hash_target_file(target_file);
-	    waiting = FALSE;
-	}
-
-	if (set.verbose >= LOW) {
-        snprintf(errstr, sizeof(errstr), "Poll round %d complete.\n", stats.round);
-		if (set.daemon)
-			sysloginfo(errstr);
-		else
-			timestamp(errstr);
-	    print_stats(stats);
-    }
+	debug(LOW, "Poll round %d complete.\n", stats.round);
+	if (set.verbose >= LOW)
+	    print_stats();
 
 	if (sleep_time <= 0)
 	    stats.slow++;
-	else
+	else {
+	    SPT("resting after round %u", stats.round);
 	    sleepy(sleep_time);
+	}
     } /* while */
 
-#ifndef FEATURES
-  #if HAVE_MYSQL
     /* Disconnect from the MySQL Database, exit. */
     if (!(set.dboff))
-	mysql_dbdisconnect(&mysql);
-  #endif
-#endif
+	mysql_dbdisconnect(&dbh_mysql);
+
     exit(0);
 }
 
@@ -260,6 +252,7 @@
     int sig_number;
 
     while (1) {
+	SPT("signal handler [waiting]");
 	sigwait(signal_set, &sig_number);
 	switch (sig_number) {
             case SIGHUP:
@@ -267,26 +260,25 @@
                     waiting = TRUE;
                 }
                 else {
-                    entries = hash_target_file(target_file);
+		    SPT("signal handler [reading targets]");
+                    hash_target_file(target_file);
                     waiting = FALSE;
                 }
                 break;
             case SIGUSR1:
-                set.verbose++;
+		if (set.verbose < THREAD)
+			set.verbose++;
                 break;
             case SIGUSR2:
-                set.verbose--;
+		if (set.verbose > OFF)
+			set.verbose--;
                 break;
             case SIGTERM:
             case SIGINT:
             case SIGQUIT:
-				debug(LOW, "Quiting: received signal %d.\n", sig_number);
+		debug(LOW, "Quiting: received signal %d.\n", sig_number);
 
-#if HAVE_MYSQL
-  #ifndef FEATURES
-                mysql_dbdisconnect(&mysql);
-  #endif
-#endif
+                mysql_dbdisconnect(&dbh_mysql);
                 unlink(pid_file);
                 exit(1);
                 break;
@@ -295,19 +287,36 @@
 }
 
 
-void usage(char *prog)
+void
+usage(char *prog)
 {
-    printf("rtgpoll - RTG v%s\n", VERSION);
-    printf("Usage: %s [-dDmz] [-vvv] [-c <file>] -t <file>\n", prog);
-    printf("\nOptions:\n");
-    printf("  -c <file>   Specify configuration file\n");
-    printf("  -d          Disable database inserts\n");
-    printf("  -D          Act as daemon\n");
-    printf("  -t <file>   Specify target file\n");
-    printf("  -v          Increase verbosity\n");
-	printf("  -m          Allow multiple instances\n");
-    printf("  -p <file>	  Specify PID file [default /var/run/rtgpoll.pid]\n"); 
-	printf("  -z          Database zero delta inserts\n");
-    printf("  -h          Help\n");
+    fprintf(stderr, "rtgpoll - RTG v%s\n", VERSION);
+    fprintf(stderr, "Usage: %s [-dDhmz] [-vvv] [-c <file>] [-p <file>] [-s <size>] -t <file>\n",
+	   prog);
+    fprintf(stderr, "\nOptions:\n");
+    fprintf(stderr, "  -c <file>   Specify configuration file\n");
+    fprintf(stderr, "  -d          Disable database inserts\n");
+    fprintf(stderr, "  -D          Act as daemon\n");
+    fprintf(stderr, "  -h          Help\n");
+    fprintf(stderr, "  -m          Allow multiple instances\n");
+    fprintf(stderr, "  -p <file>   Specify PID file [default %s]\n", PIDFILE); 
+    fprintf(stderr, "  -s <cnt>    Buckets to allocate for targets' hash (currently: %u)\n", hashsize);
+    fprintf(stderr, "  -t <file>   Specify target file\n");
+    fprintf(stderr, "  -v          Increase verbosity\n");
+    fprintf(stderr, "  -z          Database zero delta inserts\n");
     exit(-1);
 }
+
+/* Print RTG stats */
+static void
+print_stats(void)
+{
+  debug(OFF, "[Polls = %llu] [DBInserts = %llu] [Wraps = %u] [OutOfRange = %u]\n",
+      stats.polls, stats.db_inserts, stats.wraps, stats.out_of_range);
+  debug(OFF, "[No Resp = %u] [SNMP Errs = %u] [Slow = %u] [PollTime = %2.3f%c]\n",
+      stats.no_resp, stats.errors, stats.slow, stats.poll_time, 's');
+  debug(OFF, "[Hosts = %u] [Targets = %u]\n", host_count(), thash->entries);
+#ifdef FEATURES
+  debug(OFF, "[Zero = %u] [Flatline = %u]\n", stats.zero, stats.flat);
+#endif
+}
